MODULE ArrayKonstruktor;
  FROM InOut   IMPORT WriteString, WriteLn;
  FROM RealInOut IMPORT WriteFloat;

CONST
  dim    = 3;
  anzahl = dim * dim;

TYPE
  VEKTOR3   =  ARRAY [1..dim] OF REAL;
  MATRIX    =  ARRAY [1..dim] OF VEKTOR3;
  MATRIX3x3 =  ARRAY [1..dim],[1..dim] OF REAL;

VAR
  mat1 :  MATRIX3x3;
  mat2 :  MATRIX;
  i,j  :  CARDINAL;


BEGIN
  (* -- 3x3 Matrix-Elemente zuweisen -- *)
  mat1 := MATRIX3x3{1.0, 2.0, 3.0, 
                    4.0, 5.0, 6.0, 
                    7.0, 8.0, 9.0};
  mat2 := MATRIX{VECTOR3{1.0, 2.0, 3.0},
                 VECTOR3{4.0, 5.0, 6.0},
                 VECTOR3{7.0, 8.0, 9.0}};


  (* -- 3x3 Matrizen ausgeben -- *)
  WriteString("Original 3x3 Matrix 'mat1' :  "); WriteLn;
  FOR i := 1 TO dim DO                    (* zeilenweise ... *)
    FOR j := 1 TO dim DO
      WriteFloat(mat1[i,j], 2, 2);
    END;
    WriteLn
  END;
  WriteLn; WriteLn;

  WriteString("Original 3x3 Matrix 'mat2' :  "); WriteLn;
  FOR i := 1 TO dim DO                    (* zeilenweise ... *)
    FOR j := 1 TO dim DO
      WriteFloat(mat2[i,j], 2, 2);
    END;
    WriteLn
  END;
  WriteLn; WriteLn
END ArrayKonstruktor.
