MODULE BinomialKoeff;
  FROM InOut IMPORT WriteInt, Write, WriteString, WriteLn;

CONST
  nmax =  10;

VAR
  binomi  :  ARRAY [0..nmax], [0..nmax] OF INTEGER;
  n, k, l :  INTEGER;


PROCEDURE berechneBinom;

PROCEDURE initBinom;

BEGIN
  FOR n := 0 TO nmax DO
    binomi[0, n] := 1;
    binomi[n, n] := 1
  END
END initBinom;

BEGIN (* -- belegt das Feld 'binomi' *)
  initBinom;

  FOR n := 1 TO nmax DO
    FOR k := 1 TO n - 1 DO
      binomi[n, k] := binomi[n-1, k-1] + binomi[n-1, k]
    END
  END
END berechneBinom;

PROCEDURE druckePascalschesDreieck;

BEGIN
  FOR n := 1 TO nmax DO
    FOR l := 3 * n TO 3 * nmax DO
      Write(" ")
    END;
    FOR k := 1 TO n DO
      WriteInt(binomi[n, k], 6)
    END;
    WriteLn
  END
END druckePascalschesDreieck;


BEGIN (* -- Hauptprogramm -- *)
  WriteString("Pascalsches Dreieck"); WriteLn;
  berechneBinom;
  druckePascalschesDreieck
END BinomialKoeff.

