MODULE ParameterArten;
  FROM InOut IMPORT WriteString, WriteInt, WriteLn;

(*
 * -- Beispielprogramm zur Veranschaulichung der Wirkung 
 * -- verschiedener Parameterarten
 *)

VAR
  i :  INTEGER;


PROCEDURE keinParameter;

BEGIN
  WriteLn; WriteLn;
  WriteString("Wert von i in Prozedur 'keinParameter'            : ");
  WriteInt(i, 6); WriteLn;
  i := i + 1;
  WriteString("Letzter Wert von i in Prozedur 'keinParameter'    : ");
  WriteInt(i, 6); WriteLn
END keinParameter;


PROCEDURE valueParameter(
  i :  INTEGER);

BEGIN
  WriteLn; WriteLn;
  WriteString("Wert von i in Prozedur 'valueParameter'           : ");
  WriteInt(i, 6); WriteLn;
  i := i + 1;
  WriteString("Letzter Wert von i in Prozedur 'valueParameter'   : ");
  WriteInt(i, 6); WriteLn
END valueParameter;


PROCEDURE variableParameter(
  VAR i :  INTEGER);

BEGIN
  WriteLn; WriteLn;
  WriteString("Wert von i in Prozedur 'variableParameter'        : ");
  WriteInt(i, 6); WriteLn;
  i := i + 1;
  WriteString("Letzter Wert von i in Prozedur 'variableParameter': ");
  WriteInt(i, 6); WriteLn
END variableParameter;


BEGIN (* -- Beispielprogramm 'ParameterArten' -- *)
  i := 0;
  keinParameter;
  WriteString("Wert von i NACH Prozedur 'keinParameter'          : ");
  WriteInt(i, 6); WriteLn;

  i := 0;
  valueParameter(i);
  WriteString("Wert von i NACH Prozedur 'valueParameter'         : ");
  WriteInt(i, 6); WriteLn;

  i := 0;
  variableParameter(i);
  WriteString("Wert von i NACH Prozedur 'variableParameter'      : ");
  WriteInt(i, 6); WriteLn
END ParameterArten.
