MODULE ProcTypen;
  FROM InOut     IMPORT WriteString, WriteLn;
  FROM RealInOut IMPORT ReadReal, WriteReal;

CONST
  len =  31;

TYPE
  PrintStrProc =  PROCEDURE(ARRAY OF CHAR);
  RealFunc     =  PROCEDURE(REAL) :  REAL;
  CopyProc     =  PROCEDURE(    ARRAY OF CHAR, 
                            VAR ARRAY OF CHAR);


PROCEDURE SquareFunc(
  x :  REAL) :  REAL;

BEGIN
  RETURN (x * x  -  2.0 * x  + 1.0)
END SquareFunc;


PROCEDURE CopyString(
      from :  ARRAY OF CHAR;
  VAR to   :  ARRAY OF CHAR);

VAR
  i :  CARDINAL;

BEGIN
  i := 0;
  WHILE ( from[i] <> 0C ) & ( i <= HIGH(from) ) & ( i <= HIGH(to) ) DO
    to[i] := from[i];
    i     := i + 1
  END;
  IF i <= HIGH(to) THEN
    to[i] := 0C
  END
END CopyString;


VAR
  string1, string2 :  ARRAY [0..len-1] OF CHAR;
  cp               :  CopyProc;
  ps               :  PrintStrProc;
  f                :  RealFunc;
  ff               :  PROC;
  x                :  REAL;


BEGIN (* -- Hauptprogramm -- *)
  string1 := "Reelle Zahl eingeben :  ";
  cp      := CopyString;
  ps      := WriteString;
  ff      := WriteLn;
  f       := SquareFunc;

  cp(string1, string2);
  ps(string2); ReadReal(x); ff;

  ps("Ergebnis :  x^2 - 2x + 1 = "); WriteReal(f(x), 16); ff
END ProcTypen.
