MODULE TransposeMat;
  FROM InOut   IMPORT WriteString, WriteLn, ReadCard, WriteCard, Done;
  FROM SysExit IMPORT Exit;

CONST
  dim    = 3;
  anzahl = dim * dim;

VAR
  matrix :  ARRAY [1..dim],[1..dim] OF CARDINAL;
  i,j    :  CARDINAL;


BEGIN
  (* -- 3x3 Matrix zeilenweise einlesen -- *)
  FOR i := 1 TO dim DO
    FOR j := 1 TO dim DO
      ReadCard(matrix[i,j]);
      IF NOT Done
         THEN Exit(1)
      END
    END
  END;

  (* -- Original 3x3 Matrix ausgeben -- *)
  WriteString("Original 3x3 Matrix :  "); WriteLn;
  FOR i := 1 TO dim DO                    (* zeilenweise ... *)
    FOR j := 1 TO dim DO
      WriteCard(matrix[i,j], 6);
    END;
    WriteLn
  END;
  WriteLn; WriteLn;

  (* -- Transponierte 3x3 Matrix ausgeben -- *)
  WriteString("Transponierte Matrix :  "); WriteLn;
  FOR j := 1 TO dim DO                     (* spaltenweise ... *)
    FOR i := 1 TO dim DO
      WriteCard(matrix[i,j], 6);
    END;
    WriteLn
  END
END TransposeMat.
