MODULE ConvertUpperCase;
  FROM InOut IMPORT Read, Write, WriteString, WriteLn;

CONST
  ETX =  3C;

VAR
  ch :  CHAR;
  c  :  RECORD
          CASE elem :  BOOLEAN OF 
            TRUE  :  Zeichen :  CHAR   |
            FALSE :  Bits    :  BITSET
          END
        END;


BEGIN
  WriteString("Buchstaben-Zeichen eingeben (Ende <cntrl/C>)");
  WriteLn;

  REPEAT
    Read(ch);

    (* Umwandlung von Zeichen in ihre 'upper cases' 
     * konventionell:  IF ('a' <= ch) AND (ch <= 'z') THEN
     *                   ch := CHR(ORD(ch) - 32)
     *                 END;
     *                 liefert: Capital(ch)
     *
     * neue Loesung durch Bit-Manipulation ...
     *)
    c.Zeichen := ch;
    EXCL(c.Bits, 2);   (* Bit No. 5 in Zeichen = 0 *)
    Write(c.Zeichen)
  UNTIL ch = ETX
END ConvertUpperCase.
