MODULE Sets;
  FROM InOut IMPORT Write, WriteString, WriteLn;

TYPE
  COLORS   =  (red, green, blue, yellow, white, grey);
  CharSet  =  SET OF CHAR;
  ColorSet =  SET OF COLORS;

VAR
  charSet  :  CharSet;
  colorSet :  ColorSet;
  ch       :  CHAR;
  col      :  COLORS;


BEGIN
  (* -- Initialisierung ... *)
  charSet  := CharSet{'a'..'h', 'x', 'z'};
  colorSet := ColorSet{ };   (* leere Menge *)

  (* -- Operationen und Ausgaben ... *)
  charSet  := charSet * CharSet{'a', 'x'};
  colorSet := colorSet + ColorSet{green, grey};

  col := green;
  IF col IN colorSet THEN
    WriteString("green is member of colorSet")
  ELSE
    WriteString("green is not member of 'colorSet'")
  END;
  WriteLn;
  col := red;
  IF col IN colorSet THEN
    WriteString("red is member of colorSet")
  ELSE
    WriteString("red is not member of 'colorSet'")
  END;
  WriteLn;

  FOR ch := 'a' TO 'z' DO
    IF ch IN charSet THEN
      Write(ch); WriteString(" ")
    END
  END;
  WriteString("are members of 'charSet'"); WriteLn
END Sets.
